/*
    Slow solution for mutation
	Complexity: O(LCM(A,B)+M)
	Expected score: 50

	Written by Yaroslav Tverdokhlib
*/
#define _CRT_SECURE_NO_DEPRECATE
#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
using namespace std;
#define FOR(i,a,b) for (int _n(b), i(a); i <= _n; i++)
#define rep(i,n) FOR(i,1,(n))
#define rept(i,n) FOR(i,0,(n)-1)
int a,b,c,d,i,j,n,m,k,l,r;
char s1[40001],s2[40001];
int rem[40001],stages[100001];
int gcd(int a,int b)
{
	return b?gcd(b,a%b):a;
}
inline int lcm(int a,int b)
{
	return (a/gcd(a,b))*b;
}
inline int find_difference(char *s1,char *s2,int a,int b,int n)
{
	int a1=0,a2=0;
	int ans=0;
	int rr=lcm(a,b),rz=n/rr;
	n=rr;
	rept(i,n)
	{
		if (s1[a1]!=s2[a2]) ++ans;
		++a1; ++a2;
		if (a1==a) a1=0;
		if (a2==b) a2=0;
	}
	return ans*rz;
}
int main()
{
	freopen("mutation.dat","r",stdin);
	freopen("mutation.sol","w",stdout);
	scanf("%d%d%d%d",&a,&b,&n,&m);
	scanf("%s%s",s1,s2);
	c=find_difference(s1,s2,a,b,n);
	rept(i,m) scanf("%d",&stages[i]);
	if (c==0)
	{
		printf("0\n");
		exit(0);
	}
	l=r=0;
	rep(i,m)
	{
		a=stages[i-1];
		int new_r=r,new_l=l;
		unsigned int tmp=(unsigned int)new_r+a;
		if (tmp<=n) new_r+=a; else
		{
			if (tmp%2==n%2) new_r=n; else
			new_r=n-1;
		}
		if (a<=l) new_l=abs(a-l); else
		if (a>=r) new_l=abs(a-r); else
		if (a%2==r%2) new_l=0; else
		new_l=1;
		l=new_l;
		r=new_r;
		if (c>=l && c<=r && c%2==r%2)
		{
			printf("%d\n",i);
			exit(0);
		}
	}
	printf("-1\n");
}
